      subroutine th_22index(isubthe,icase,iput,iget,info) 
      use glbconst, only: maxfr1,maxfr2,maxthss,maxscrd,               &
                          icstrf,ivstrf,ivfr1trf,nwr
      use comthe, only: array_fr,theoryname,mLG
      implicit none 
                                                                        
!     called by i.e. stroboscopy and synchrotron                        
                                                                        
      integer isubthe,icase,iput,iget,info,dstr,idex,                   &
              ipLG,idum11,iflag_basis,l_Poincare,nLG,nTH,               &
              idum1,nsampling,ak8,idum2                                 
      real    srw8 
      integer,parameter::istr=38+4*(maxfr1+maxfr2)+3*maxthss+4 
      common/struct/dstr(istr),ipLG,idum11(11),iflag_basis,l_Poincare,  &
                    nLG,nTH,idum1,nsampling,ak8,idum2,srw8,idex(7)      
                                                                        
      logical       b_vsp,b_v_max,b_dumvsp 
      common/bvstrf/b_vsp(4),b_v_max,b_dumvsp(ivstrf-5) 
                                                                        
      logical        b_vfr1trf 
      common/bvfr1trf/b_vfr1trf(ivfr1trf) 
                                                                        
!     storage use nst2_8 for 4 complex numbers of r_ik                  
      real          c1,gamnat,e_xsi,flag_SAMP,flag_Voigt,dumc 
      common/acmaps/c1,gamnat,e_xsi,flag_SAMP,flag_Voigt,dumc(icstrf-5) 
      real          avm,sftr,aisom,w_Gauss,w_Lorentz,dumv 
      logical       b_vm,b_sftr,b_isom,b_w_Gauss,b_w_Lorentz,b_dumv 
      common/avmaps/avm,sftr,aisom,w_Gauss,w_Lorentz,dumv(ivstrf-5) 
      common/bvmaps/b_vm,b_sftr,b_isom,b_w_Gauss,b_w_Lorentz,           &
                    b_dumv(ivstrf-5)                                    
                                                                        
      integer,parameter::idumscrd=maxscrd-2*(2*mLG+1)-2*(mLG+1) 
      real        sTr,dumscrd 
      complex     cLG 
      common/scrd/sTr(-mLG:mLG+1),cLG(-mLG:mLG),dumscrd(idumscrd) 
                                                                        
      logical   b_Poincare,b_pc,bxx 
      integer   iflag_SAMP,iflag_Voigt,nd,iposLG,nE,jge,                &
                i,ip,j,jn,k,l,n,ni,nget,n_all,nall                      
                                                                        
      real      Eagd,hti,srw,sqrt2,azz,d_x2,aszz,dsx2,fd 
      complex   hc,hci,pp_mm,ppmm,                                      &
                ctr,cpm,cmp,hrtr,hrpm
      complex,dimension(2,2):: trv,TSPCA,sph                            
                                                                        
                                                                        
      if(isubthe.lt.0) then 
       c1=8*(nTH+1) 
       theoryname='2x2_refraction_index_static     v=101' 
       return 
      end if 
                                                                        
      hci=cmplx(0.,1.) 
      iflag_SAMP=flag_SAMP 
      if(icase.eq.0)iflag_SAMP=0 
      iflag_Voigt=flag_Voigt 
      b_Poincare=l_Poincare.eq.1 
                                                                        
!      write(6,'(a,4i6)') '22index ....isubthe,nLG=',isubthe,nLG        
                                                                        
!     i.e  th_hdeq                                                      
      call get_theory(isubthe,info) 
      if(info.gt.0) return 
      b_pc=b_v_max.or.b_isom.or.b_w_Gauss.or.b_w_Lorentz.or.isubthe.gt.0 
      if(.not.b_pc.or.info.gt.0) then 
       isubthe=-abs(isubthe) 
       return 
      end if 
      isubthe=abs(isubthe) 
                                                                        
      nget=real(array_fr(iget+1)) 
      n_all=real(array_fr(nget+1)) 
      jge=aimag(array_fr(nget+1)) 
      bxx=real(array_fr(nget+2)).gt.0.01 
                                                                        
!         write(6,'(a,5i7)') ' Eagd jge,iput,iget=',                    
!     &         jge,iput,iget,iput+8*nTH                                
!        write(6,'(a,L5,3i4)') 'b_Poincare,iflag_basis,iflag_SAMP=',    
!     &                         b_Poincare,iflag_basis,iflag_SAMP       
!-----------------------------------------------------------------------
!      basis for linear polarization                                    
      if (iflag_basis.eq.0) then 
       sqrt2=1./sqrt(2.) 
       TSPCA(1,1)=cmplx( sqrt2,0.) 
       TSPCA(1,2)=cmplx(-sqrt2,0.) 
       TSPCA(2,1)=cmplx(0.,-sqrt2) 
       TSPCA(2,2)=cmplx(0.,-sqrt2) 
!      transformation matrix from spherical basis to (sigma,pi)-basis   
       do nall=1,n_all 
        ip=nget+2+3*jge*(nall-1) 
        do jn=ip,ip+jge*3-2,3 
         pp_mm=real(array_fr(jn+2)) 
         ppmm =aimag(array_fr(jn+2)) 
                                                                        
         sph(1,1)= pp_mm+ppmm 
         sph(2,2)=-pp_mm+ppmm 
         sph(1,2)= array_fr(jn+3) 
         sph(2,1)= conjg(sph(1,2)) 
                                                                        
         do i=1,2 
         do k=1,2 
          hc=cmplx(0.,0.) 
          do j=1,2 
          do l=1,2 
           hc=hc+TSPCA(i,l)*sph(l,j)*conjg(TSPCA(k,j)) 
          end do 
          end do 
          trv(i,k)=hc 
         end do 
         end do 
         array_fr(jn+2)=cmplx(real(trv(1,1)-trv(2,2)),                  &
                        real(trv(1,1)+trv(2,2)))/2.                     
         array_fr(jn+3)=trv(1,2) 
                 ! jn=                                                  
        end do 
                ! nall=1,n_all                                          
       end do 
      end if 
                                                                        
!---------------------------------------------------------------------- 
                                                                        
      i=8 
      do n=iput+1,iput+(nTH+1)*i 
       array_fr(n)=(0.,0.) 
      end do 
                                                                        
      if(iflag_SAMP.eq.1) then 
       do nall=1,n_all 
        ip=nget+2+3*jge*(nall-1) 
        do jn=ip+1,ip+jge*3-2,3 
         Eagd=real(array_fr(jn))+aisom 
                                         ! nE <= sk8                    
         nE=ifix(Eagd/srw8+0.5) 
         if (abs(nE).gt.ak8) write(nwr,'(2(a,f10.2),a)')                &
           '**** E(sample)=',Eagd,' out of range ',ak8*srw8,'[mm/s]'    
        end do 
       end do   ! nall=1,n_all 
                                                                        
       call cLORGAU(gamnat,e_xsi,                                       &
           srw8,w_Lorentz,w_Gauss,nLG,iflag_Voigt,ipLG,iposLG)          
                                                                        
!        write(6,'(a,2i6,/,4f12.5)')                                    
!        'iposLG,nLG,array_fr(iposLG,+1)=',                            
!        nLG,iposLG,                                                   
!        array_fr(iposLG),array_fr(iposLG+1)                           
                                                                        
       do nall=1,n_all 
        ip=nget+2+3*jge*(nall-1) 
                                                                        
        if(bxx) then 
         aszz=aimag(array_fr(ip+1)) 
         dsx2=aimag(array_fr(ip+4)) 
         azz =aimag(array_fr(ip+7)) 
         d_x2=aimag(array_fr(ip+10)) 
         fd=exp(-azz*d_x2-aszz*dsx2) 
        else 
         fd=exp(-aimag(array_fr(ip+13))) 
        end if 
                                                                        
        do jn=ip,ip+jge*3-3,3 
                                                                        
         hrtr=array_fr(jn+2)*fd 
         hrpm=array_fr(jn+3)*fd 
                                                                        
                                                                        
         Eagd=real(array_fr(jn+1))+aisom 
         nE=ifix(Eagd/srw8+0.5) 
                                                                        
         if(b_Poincare) then 
           hti = aimag(hrtr)/2.0 
           ctr= real(hrtr)*hci/2.0 
           cpm= hrpm*hci/2.0 
           cmp= conjg(hrpm)*hci/2.0 
         else 
!         shape of rho-hatrix                                           
           hti = aimag(hrtr)+real(hrtr) 
           ctr= cmplx(aimag(hrtr)-real(hrtr),0.) 
           cpm= hrpm 
           cmp= conjg(hrpm) 
!         write(6,'(l5,2x,8f12.4)').not.b_Poincare,Eagd,hti,ctr,cpm     
         end if 
!        write(6,'(a,4i6,f15.6)')'nsampling,nLG,nTH,iposLG,srw8=',      
!     &                           nsampling,nLG,nTH,iposLG,srw8         
                                                                        
         do n=0,nTH 
          ni=iput+8*n 
          nd=nsampling*n-nE 
          if(abs(nd).le.nLG) then 
                                                                        
!          nkz=kz*I-Sum;ab rpq(ab)/2*(-i+(E-Eab)/hga)*LG(E-Eab)         
!          nkz=kz*I-Sum;ab rpq(ab)/2*(-i*LGi(E-Eab)+LGr(E-Eab))         
!          b1=1/2 kz*(npm+nmp)                                          
!          b2=1/2 kz*(npm-nmp)*i                                        
!          b3=1/2 kz*(npp-nmm)                                          
!                                                                       
!          the factor 1/4 is the factor in 1/2 kz*(...) and in npq ( 1/2
!          fLG=(4*n-nE)*srw8/(hga/2.) is written as                     
                                                                        
           if(nd.gt.0) then 
            hc=conjg(array_fr(iposLG+nd)) 
           else 
            hc=-array_fr(iposLG-nd) 
           end if 
           array_fr(ni+1)=array_fr(ni+1)-hc*hti 
           array_fr(ni+2)=array_fr(ni+2)-hc*ctr 
           array_fr(ni+3)=array_fr(ni+3)-hc*cpm 
           array_fr(ni+4)=array_fr(ni+4)-hc*cmp 
          end if 
!          if(n.lt.5) write(6,'(3i6,8f9.4)') iflag_SAMP,n,i,hc*100.     
                                                                        
           nd=-nsampling*n-nE 
           if(abs(nd).le.nLG) then 
            if(nd.gt.0) then 
             hc=conjg(array_fr(iposLG+nd)) 
            else 
             hc=-array_fr(iposLG-nd) 
            end if 
            array_fr(ni+5)=array_fr(ni+5)-hc*hti 
            array_fr(ni+6)=array_fr(ni+6)-hc*ctr 
            array_fr(ni+7)=array_fr(ni+7)-hc*cpm 
            array_fr(ni+8)=array_fr(ni+8)-hc*cmp 
           end if 
                                                                        
                                                                        
                      ! nTH                                             
         end do 
                     ! jn=                                              
        end do 
                     ! n_all                                            
       end do 
      else 
       srw=srw8*nsampling 
!      write(6,'(a,3i8,f15.6)')'nsampling,nLG,nTH,srw8=',               
!     &                           nsampling,nLG,nTH,srw8                
                                                                        
       do nall=1,n_all 
        ip=nget+2+3*jge*(nall-1) 
                                                                        
        if(bxx) then 
         aszz=aimag(array_fr(ip+1)) 
         dsx2=aimag(array_fr(ip+4)) 
         azz =aimag(array_fr(ip+7)) 
         d_x2=aimag(array_fr(ip+10)) 
         fd=exp(-azz*d_x2-aszz*dsx2) 
        else 
         fd=exp(-aimag(array_fr(ip+13))) 
        end if 
                                                                        
        do jn=ip,ip+jge*3-3,3 
                                                                        
         hrtr=array_fr(jn+2)*fd 
         hrpm=array_fr(jn+3)*fd 
!         b_Poincare=.false.                                            
         Eagd=real(array_fr(jn+1))+aisom 
!         write(6,'(i8,4f12.6)') jn,hrtr,hrpm,Eagd                           
         if(b_Poincare)then 
          hti=aimag(hrtr)/2.0 
          ctr=real(hrtr)*hci/2.0 
          cpm=hrpm*hci/2.0 
          cmp=conjg(hrpm)*hci/2.0 
         else 
          hti=aimag(hrtr)+real(hrtr) 
          ctr=cmplx(aimag(hrtr)-real(hrtr),0.) 
          cpm=hrpm 
          cmp=conjg(cpm) 
         end if 
                                                                        
                                                                        
         call aLORGAU(Eagd,gamnat,e_xsi,                                &
               srw,w_Lorentz,w_Gauss,nTH,iflag_Voigt)                   
                                                                        
         do n=0,nTH 
          ni=iput+8*n 
          hc=conjg(cLG(n)) 
!        if(abs(n).lt.5) write(6,'(a,2i6,8f9.4)')                       
!     &     ' nTH, n,i,hc*100.=',nTH,n,hc*100.                          
                                                                        
          array_fr(ni+1)=array_fr(ni+1)-hc*hti 
          array_fr(ni+2)=array_fr(ni+2)-hc*ctr 
          array_fr(ni+3)=array_fr(ni+3)-hc*cpm 
          array_fr(ni+4)=array_fr(ni+4)-hc*cmp 
          hc=conjg(cLG(-n)) 
                                                                        
          array_fr(ni+5)=array_fr(ni+5)-hc*hti 
          array_fr(ni+6)=array_fr(ni+6)-hc*ctr 
          array_fr(ni+7)=array_fr(ni+7)-hc*cpm 
          array_fr(ni+8)=array_fr(ni+8)-hc*cmp 
                      ! n loop                                          
         end do 
                                                                        
                     !   jn=                                            
        end do 
                     ! nall=1,n_all                                     
       end do 
                                                                        
                                                                        
!      write(6,'(a1,2i8,2f10.4)')                                       
!     & ('m',i,iput+i,array_fr(iput+i+1),i=0,8*nTH,nTH)                 
                     ! iflag_SAMP                                       
      end if 
                                                                        
      return 
      END                                           
