      subroutine udp(mf,uu,chisq,pathw,chi_p,cmch,info) 
      use glbconst, only: max8,maxscrt,maxpf,maxco,MDBPLFT,max_vtrf,   &
                          infotext,nwr
      use comfrm, only: mtrp,p,pl,kp,kpl,kcp,mco,mc,mcs,mrces,mr,mrs,   &
                        cpstor,ddp,mprdn,ivadd
      use comdat, only: mfpt,mdfpt,ichanks
      use comthe, only: iarray_sp,array_fr,real_fr,thfk,dfdp,ddpk,      &
                        ib_df,kana,ibmisfit,vartrf,ovartrf
      use comths, only: nstorSP,dp,idfdpk,kf,i_opgtup,df_mc,idf_min,nfit
      implicit none 
                                                                        
      integer            mf,info 
      real               chisq,pathw,chi_p
      character(len=4):: cmch 
      real,dimension(mf,mf):: uu
                                                                        
      integer   idfsum,ijv,idumsc,kp_f 
      real      dfdpk,dather,ukk,dpudp 
      integer, parameter::idumscrt=maxscrt-9*max8-2*maxpf-maxco*8-1 
      common/scrt/ukk(maxpf),dpudp,                                     &
                  dfdpk(max8*8),dather(max8),idfsum(maxpf),ijv(maxco*8),&
                  idumsc(idumscrt)                                      
                                                                        
      real        z,zi,hh,hk,hp,h,ztheo,dtheory 
      complex     artmp 
      common/plot/artmp(MDBPLFT) 
      integer     nf,ktr,ic,j,k,l,ks,n1,ichisq,i,nnf,nch,kpf,kpa,       &
                  j0,j1,j2,ij,ir,mk,iv,idfdp,lpf,mfo,                   &
                  mchan,kpfm1_mchan,lpfm1_mchan                           
      complex, dimension(:), allocatable :: fitstorage 
                                                                      
      nf=0 
      z=0.0 
      do ktr=1,mco 
       do ic=1,mc(ktr) 
        j=kcp(mcs(ktr)+ic) 
        mtrp(j)=ktr 
       end do 
      end do 
!     write(6,'(a,10i4)') 'mtrp=',(mtrp(i),i=1,mco)                     
!      write(6,'(20i4)') (kf(i),i=1,mf)                                 
                                                                        
      do  k=1,mf 
       dp(k)=0. 
       idfsum(k)=0 
       do l=1,mf 
        uu(k,l)=0. 
       end do 
      end do 
                                                                        
!      write(6,'(a,8i4)')'fit nfit(0..)=',(nfit(i),i=0,nfit(0))         
       do k=nfit(0),2,-1 
        ks=nfit(k) 
        n1=1 
        call frametheory(ks,'test',n1,info) 
        if(info.gt.0) return 
       end do 
                                                                        
      ichisq=0 
      do k=1,nfit(0) 
        ks=nfit(k) 
        n1=1 
        call frametheory(ks,'test',n1,info) 
        if(info.gt.0) return 
        if(nstorSP.lt.MDBPLFT) then 
         do i=1,nstorSP 
          artmp(i)=array_fr(iarray_sp+i) 
         end do 
        else
         allocate(fitstorage(1:nstorSP))
!        write(6,*) ' MDBPLFT,nstorSP=',MDBPLFT,nstorSP
         do i=1,nstorSP 
          fitstorage(i)=array_fr(iarray_sp+i) 
         end do 
        end if 
!----------------------------------------------------                   
!        ka=nstorTH+2                                                   
!        write(6,'(a,4i8)') ' fit before ka,iarray_sp,nstorSP=',        
!     &                                  ka,iarray_sp,nstorSP           
!        write(6,'(4g15.5)') (array_fr(ka+i),i=1,256,32)                
!----------------------------------------------------                   
!        write(6,'(a,i5)') 'fit  udp  data mfpt=',mfpt                  
!        write(6,'(a,i5)') 'fit  udp  data mdfpt=',mdfpt                
        zi=0. 
        nnf=0 
        do j=2,ichanks(0),2 
         do i=ichanks(j-1),ichanks(j) 
          nnf=nnf+1 
          dather(i)=(real_fr(mfpt+i)-thfk(i))/real_fr(mdfpt+i) 
          zi=zi+dather(i)**2 
          if(abs(dather(i)).lt.1) ichisq=ichisq+1 
         end do 
        end do 
        nf=nf+nnf 
        z=z+zi 
!        write(6,'(a,i6,a,g15.6)') ' fit ks=',ks,' zi=',zi              
!        write(6,'(15f15.6)')(p(kf(k)),k=1,mf)                          
        n1=2    ! derivatives kpf=1,mf  
!--------------------------------------------------                     
        mchan=ichanks(ichanks(0)) 
        do kpf=1,mf 
!        write(6,'(a,2i2)')'******fit udp  kpf=',kpf                     
         kpfm1_mchan=(kpf-1)*mchan 
                                                                        
         kpa=kf(kpf) 
         ddpk=ddp(kpa)*pathw 
         p(kpa)=p(kpa)+ddpk 
         dtheory=df_mc/ddpk*2.0 
                                                                        
         j=1 
         j0=mprdn(j) 
         do while(j0.gt.0) 
          j1=mprdn(j+1) 
          j2=mprdn(j+2) 
          p(j0)=p(j1)*p(j2) 
          j=j+3 
          j0=mprdn(j) 
         end do 
                                                                        
         ktr=mtrp(kpa) 
!        write(6,'(a,10i4)') 'ktr,mr(ktr),mc(ktr)=',ktr,mr(ktr),mc(ktr) 
         ij=0 
         do ir=1,mr(ktr) 
          mk=mrces(ktr)+(ir-1)*mc(ktr) 
          hh=0. 
          do ic=1,mc(ktr) 
           j=kcp(mcs(ktr)+ic) 
           hh=hh+cpstor(mk+ic)*p(j) 
          end do 
          j=kpl(mrs(ktr)+ir) 
          pl(j)=hh 
          ij=ij+1 
          ijv(ij)=j 
         end do 
!        write(6,'(a,10i4)') 'ijv=',(ijv(i),i=1,ij)                     
         do j=1,ij 
          i=ijv(j) 
          vartrf(ivadd(i))=pl(i) 
         end do 
!--------------------------------------------------                     
         call frametheory(ks,'dfdp',n1,info) 
         if(info.gt.0) return 
!--------------------------------------------------                     
         p(kpa)=p(kpa)-ddp(kpa)*pathw 
                                                                        
         do ir=1,mr(ktr) 
          mk=mrces(ktr)+(ir-1)*mc(ktr) 
          hh=0. 
          do ic=1,mc(ktr) 
           j=kcp(mcs(ktr)+ic) 
           hh=hh+cpstor(mk+ic)*p(j) 
          end do 
          j=kpl(mrs(ktr)+ir) 
          pl(j)=hh 
         end do 
                                                                        
         do j=1,ij 
          i=ijv(j) 
          iv=ivadd(i) 
          vartrf(iv)=pl(i) 
          ovartrf(iv)=pl(i) 
!          write(6,'(a,4i6,2g15.5)')                                    
!     &   'fit kana,j,i,iv,vartrf,ovartrf(iv)=',                        
!     &                    kana,j,i,iv,vartrf(iv),ovartrf(iv)           
         end do 
!--------------------------------------------------                     
!        write(6,'(a,3i5)') ' fit kpf,ks,idf=',kpf,ks,idfdpk()          
         idfdp=0 
         if(ib_df.eq.1) then 
          if(kana.eq.0.or.nstorSP.lt.MDBPLFT) then 
           do i=1,nstorSP 
            array_fr(iarray_sp+i)=artmp(i) 
           end do 
          else
!          write(6,'(a,3i7)') ' nstorSP.lt.MDBPLFT=',nstorSP,MDBPLFT
           do i=1,nstorSP 
            array_fr(iarray_sp+i)=fitstorage(i) 
           end do 
          end if 
          hp=0. 
          nnf=0 
          do j=2,ichanks(0),2 
           do i=ichanks(j-1),ichanks(j) 
            nnf=nnf+1 
            hh=dfdp(i)/real_fr(mdfpt+i) 
            if(abs(hh).gt.dtheory) idfdp=idfdp+1 
            hp=hp+hh*dather(i) 
            dfdpk(kpfm1_mchan+i)=hh 
           end do 
          end do 
                                                                        
!         write(6,'(a,3i5,3g10.4)')'fit kpf,ks,idfdp,hp,dtheory=',      
!     &                               kpf,ks,idfdp,hp,dtheory           
          dp(kpf)=dp(kpf)+hp 
          idfdp=(idfdp*100)/nnf 
          idfdpk(kpf,ks)=idfdp 
          idfsum(kpf)=idfsum(kpf)+idfdp 
         else 
          idfdpk(kpf,ks)=0 
         end if 
!         write(6,'(a,i2,a2,2i4)')' fit idfdp,idfsum(',kpf,')=',        
!     &       idfdp,idfsum(kpf)                                         
                  ! kpf=1,mf                                            
        end do 
        if(nstorSP.gt.MDBPLFT) deallocate(fitstorage)
                                                                
!        write(6,'(a,i4)')' fit mf=',mf                                 
        do kpf=1,mf 
         kpfm1_mchan=(kpf-1)*mchan 
         if(idfdpk(kpf,ks).gt.0) then 
          do lpf=kpf,mf 
           lpfm1_mchan=(lpf-1)*mchan 
           if(idfdpk(lpf,ks).gt.0) then 
            hk=0 
            do j=2,ichanks(0),2 
             do i=ichanks(j-1),ichanks(j) 
              hk=hk+dfdpk(lpfm1_mchan+i)*dfdpk(kpfm1_mchan+i) 
             end do 
            end do 
            uu(kpf,lpf)=uu(kpf,lpf)+hk 
            uu(lpf,kpf)=uu(kpf,lpf) 
           end if 
          end do ! lpf=kpf..mf 
!          write(6,'(i4,10g12.4)')kpf,(uu(kpf,lpf),lpf=1,mf)             
         end if 
        end do    ! kpf=1..mf
!--------------------------------------------------                     
                  ! ks                                                  
      end do 
!      write(6,'(20i4)') (kf(j),j=1,mf)                                 
       mfo=mf 
       kpf=1 
       kp_f=0 
       do while(kpf.le.mf) 
        kp_f=kp_f+1 
!        write(6,'(a,3i4)')' fit kpf,idfsum(kpf)=',                     
!     &                kp_f,idfsum(kp_f),idf_min                        
        if(idfsum(kp_f).lt.idf_min) then 
         kpfm1_mchan=(kp_f-1)*mchan 
         h=0.0 
         nch=0 
         do k=2,ichanks(0),2 
          do i=ichanks(k-1),ichanks(k) 
           h=h+abs(dfdpk(kpfm1_mchan+i)) 
           nch=nch+1 
          end do 
         end do 
         kpa=kf(kpf) 
!        write(6,'(a,4f12.5)') ' h,ddp(kpa),pathw=',h,ddp(kpa),pathw    
         h=h/nch*ddp(kpa)*pathw 
!         if(i_wfix.eq.1) then                                          
          if(idfsum(kp_f).eq.0) then 
           info=-1 
           write(nwr,'(a,i3,a)')                                        &
          ' ***warning*** p',                                           &
           kpa,' fixed: belongs to sets currently not fitted'           
          else 
           write(nwr,'(a,i3,a,e8.1,a,i3,a,e8.1,a1)')                    &
          ' ***warning*** p',kpa,' fixed: df_mc=',df_mc,                &
          ' > (df/dp)*dp at ',100-idfsum(kp_f),                         &
          '% of channels (<(df/dp)*dp>=',h,')'                          
          end if 
!         end if                                                        
         kp(kpa)=0 
         do k=kpf,mf-1 
          kf(k)=kf(k+1) 
          dp(k)=dp(k+1) 
          i_opgtup(k)=i_opgtup(k+1) ! 17.11.05 
         end do 
         do k=kpf,mf-1 
          do lpf=1,mf 
           uu(lpf,k)=uu(lpf,k+1) 
          end do 
         end do 
         do k=kpf,mf-1 
          do lpf=1,mf-1 
           uu(k,lpf)=uu(k+1,lpf) 
          end do 
         end do 
         mf=mf-1 
         kpf=kpf-1 
        end if 
        kpf=kpf+1 
       end do 
       if(mf.eq.0) then 
        info=1 
        infotext(1)='effi/fit/fix_all' 
        infotext(2)='**error** all parameters fixed'//                  &
     &      ' no variation  found '                                     
        infotext(3)=' ' 
        return 
       end if 
       ztheo=nf-mf 
       chisq=z/ztheo 
       chi_p=float(ichisq*100)/nf 
                                                                        
       if(cmch.eq.'grad') then 
        do k=1,mf 
         ukk(k)=uu(k,k) 
         if(ukk(k).le.0.0) ukk(k)=1.0 
         dp(k)=dp(k)/ukk(k) 
        end do 
                                                                        
        dpudp=0. 
        do k=1,mf 
         do l=1,mf 
         dpudp=dpudp+dp(k)*uu(k,l)*dp(l) 
         end do 
        end do 
       end if 
!       write(6,'(a,8f10.3)')'fit udp p=',(p(kf(k)),k=1,mf)             
                                                                        
       if(mfo.gt.mf) call untom(mfo,mf,uu) 
                                                                        
      return 
      END                                           
                                                                        
      subroutine untom(n,m,u) 
      implicit none
      integer n,m,j,k
      real,dimension(n*n):: u 
!      write(6,'(a)')'untom(n,m,u) u='                                  
!      write(6,'(8f10.3)')(u(i),i=1,n*n)                                
      do j=1,m-1 
       do k=1,m 
        u(j*m+k)=u(j*n+k) 
       end do 
      end do 
!      write(6,'(8f10.3)')(u(i),i=1,n*n)                                
      return 
      END                                           
                                                                        
      subroutine uinvdp(mf,u,dp,fuu,alambda) 
      implicit none
      integer   mf,j,ncase
      real, dimension(mf,mf):: u      
      real, dimension(0:mf) :: fuu
      real, dimension(mf)   :: dp
      real alambda,h
                                                                  
      if(alambda.gt.0.0) then 
       h=1.0+alambda 
       do j=1,mf 
        u(j,j)=u(j,j)*h 
       end do 
      else if(fuu(0).gt.0.0) then 
       do j=1,mf 
        u(j,j)=u(j,j)*fuu(j) 
       end do 
      end if 
      ncase=0 
      call lineq (ncase,mf,u,dp) 
      return 
      END                                           
                                                                        
      subroutine trf_arr(k,uinv,u) 
      implicit none
      integer   k,j
      real,dimension(k*k):: uinv,u 
      do j=1,k*k 
       uinv(j)=u(j) 
      end do 
      return 
      END                                           
                                                                        
      subroutine fit(cmch,mf,iter_count,pathw,                          &
                          ochisq,chisq,chi_p,path1,path2,info)          
      use glbconst, only: maxscrt,maxpf,max8,max_vtrf,nwr
      use comfrm, only: p,ddp,np,pold,plast
      use comdat, only: mfpt,mdfpt,b_datset,ichanks
      use comthe, only: real_fr,thfk,dfdp,ibmisfit
      use comths, only: chitest,dp,kf,i_opgtup,ntest,hopmp,hupmp,boundary, &
                        covar,ftol,iBR_DBR,limit,i_confine,ibx_calc,iterbrake,&
                        tolimit
      implicit none 
                                                                        
      integer   mf,info,iter_count 
      real      pathw,ochisq,chisq,chi_p,path1,path2,h 
      character(len=24):: format
      character(len=24),dimension(maxpf):: namepp
      character(len=4) :: cmch,omch='0000'

      real      vartrf,ovartrf 
      common/vtrf/ vartrf(max_vtrf),ovartrf(max_vtrf) 
                                                                        
      integer   idumsc 
      real      ukk,dpudp 
      integer,parameter::idumscrt=maxscrt-maxpf-1 
      common/scrt/ukk(maxpf),dpudp,idumsc(idumscrt) 
                                                                        
      integer   mff
      real      hop,hup,odpudp
      integer,dimension(maxpf):: kfff,kff,if_opgtup,iff_opgtup
      real,   dimension(maxpf):: df,hp,hdp,hukk,hhdp,hhukk,PT,PTT,XIT
      real, dimension(0:maxpf):: fuu
      real,   dimension(maxpf,maxpf):: uu
                                                                       
      logical b_misfit 
      integer nf,nfs,k,ks,i,j,j1,m,mfff,luu,kpa,jfit,misft 
      real    z,zs,gp,g2,alambda,g1,pathmin,hpath,zm,zmis,derr 
!     ******************************************************************
!     cmch =   test                                                     
!     cmch =   newt on                                                  
!     cmch =   grad ient                                                
!     cmch =   marq uardt                                               
!     cmch =   powe l                                                   
!     test                                                              
!       write(6,'(2a)')'fit fit cmch=',cmch                             
                                                                        
!       do  k=1,mf                                                      
!        write(6,'(a,i2,a,a24,2x,i2,g12.3)') 'fit kf(k)=',kf(k),        
!     &               ' nthpl=',np(kf(k)),i_opgtup(k),p(kf(k))          
!       end do                                                          
                                                                        
      if (cmch.eq.'test') then 
       zmis=0. 
       misft=0 
       jfit=0 
       zs=0. 
       nfs=0 
       gp=0.0 
!       write(6,'(a,9i3)')'fit ntest=',(ntest(k),k=1,ntest(0))          
       do k=1,ntest(0) 
        ks=ntest(k) 
        chitest(k)=-1. 
        if(b_datset(ks))then 
         jfit=jfit+1 
         j1=1 
         call frametheory(ks,'test',j1,info) 
!        write(6,'(a,i8)')' fit nstorSP=',nstorSP                       
         if(info.gt.0) return 
         z=0. 
         zm=0. 
         nf=0 
         b_misfit=ibmisfit.eq.1 
         do j=2,ichanks(0),2 
!          write(6,'(a,2i8)')' fit mfpt,mdfpt=',mfpt,mdfpt              
!          write(6,'(5g15.3)')(real_fr(4408+i),i=1,5)                   
                                                                        
          do i=ichanks(j-1),ichanks(j) 
           nf=nf+1 
           derr=real_fr(mdfpt+i) 
           g2=((real_fr(mfpt+i)-thfk(i))/derr)**2 
!          write(10,'(i6,3f13.1)') i,real_fr(mfpt+i),thfk(i),derr       
           z=z+g2 
           if (g2.lt.1.) gp=gp+1.
!                              dfdp=base *geo   
           if(b_misfit)zm=zm+((dfdp(i)-thfk(i))/derr)**2 
          end do 
         end do 
!         close(unit=10)                                                
         if(b_misfit)then 
          zmis=zmis+(z-float(nf))/(zm-float(nf))*1000 
          misft=misft+1 
!          write(nwr,'(a,g15.6,a2,i2,a1)') ' misfit=',                  
!     &             (z-float(nf))/(zm-float(nf)),' (',ks,')'            
         end if
!        write(6,'(a,i6,a,g15.6)') ' test ks=',ks,' zi=',z       
         chitest(k)=z/nf 
         zs=zs+z 
         nfs=nfs+nf 
        end if 
       end do 
!      write(6,'(a,i6,a,g15.6)') ' fit ks=',ks,' z=',z                  
!      write(6,'(15f15.6)')(p(kf(k)),k=1,mf)                            
!       write(6,'(a,f15.4,2(a,i6))') ' zs=',zs,' nf=',nf,'  mf=',mf     
       chitest(0)=0. 
       if(nf.gt.0) then 
        chisq=zs/(nfs-mf) 
        if(ochisq.eq.0)ochisq=chisq 
        chi_p=gp*100./float(nfs) 
        if(misft.eq.jfit)then 
         chitest(0)=zmis/misft 
        end if 
       else 
        chi_p=0. 
        chisq=0. 
       end if 
       return 
      end if 
                                                                        
                                                                        
      path1=1. 
!     maxpf=32 ! dimension of array dfdpk(maxn,maxpf)                   
!     mf is the dimension of the reduced set (dp,u) used in the fit rout
!     kp(k)>0 are set to kp(k)=mf                                       
                                                                        
!     compute function value f and derivatives df at channel i          
!     set initial values                                                
                                                                        
      alambda=path2 
      if(omch.eq.'0000'.or.omch.ne.cmch) then 
!       write(6,'(3(a,f15.5))') 'start before udp p(m)=',p(kf(1))       
       call udp(mf,covar,ochisq,pathw,chi_p,cmch,info) 
!       write(6,'(4(a,g15.5))') 'start dpudp=',dpudp,' alambda=',alambda
!              ' ochisq=',ochisq                                       
      end if 
      fuu(0)=0.0 
!--------------------------------- Levenberg-Marquardt------------------
      if (cmch.eq.'marq') then 
       omch='marq' 
!      dp(k) for Marquard's  method                                     
!      solve normal equations                                           
       mff=mf 
       do k=1,mf 
        kff(k)=kf(k) 
        hdp(k)=dp(k) 
        if_opgtup(k)=i_opgtup(k) 
       end do 
       call trf_arr(mf,uu,covar) 
       call uinvdp(mf,covar,dp,fuu,alambda) 
                                                                        
       do k=1,mf 
        dp(k)=pathw*dp(k) 
       end do 
                                                                        
       do  k=1,mf 
        m=kf(k) 
        if(i_opgtup(k).eq.1) then 
         hop=p(m)+dp(k)-hopmp(k) 
         hup=p(m)+dp(k)-hupmp(k) 
         if(hop.gt.0.and.dp(k).gt.0.) then 
!          write(nwr,6800) np(kf(k)),p(m)+dp(k),hopmp(k),dp(k)          
          p(m)=p(m)+dp(k)*exp(-hop/dp(k))*tolimit 
          write(nwr,6800) np(kf(k)),p(m) 
         else if(hup.lt.0.and.dp(k).lt.0.) then 
!          write(nwr,6800) np(kf(k)),p(m)+dp(k),hupmp(k),dp(k)          
          p(m)=p(m)+dp(k)*exp(-hup/dp(k))*tolimit 
          write(nwr,6800) np(kf(k)),p(m) 
         else 
          p(m)=p(m)+dp(k) 
         end if 
        else 
         if(abs(dp(k)).gt.100.*abs(ddp(m)))then 
           z=sign(ddp(m),dp(k))/2.0 
           format='(a,i2,a2,g12.4,a,g12.4)' 
           if(k.gt.100)format='(a,i4,a2,g12.4,a,g12.4)' 
           write(nwr,format)                                            &
         ' -singular- dp(',k,')=',dp(k),' set to sign(ddp,dp)/2.0=',z   
           dp(k)=z 
         end if 
         p(m)=p(m)+dp(k) 
        end if 
       end do 
                                                                        
       call calpl('free') 
!       call udp(mf,u,chisq,chi_p,ukk,dpudp,cmch,info)                  
       call udp(mf,covar,chisq,pathw,chi_p,cmch,info) 
!       write(6,'(a,20i4)') ' fit:',(kf(i),i=1,mf)                      
!       write(6,'(4(a,g15.3))') '* alambda=',alambda,                   
!     &         ' chisq=',chisq,' ochisq=',ochisq,' chi_p=',chi_p       
                                                                       
      if(limit.eq.0)then
       if(chisq.lt.ochisq) then
        alambda=0.2*alambda
       else 
        alambda=5*alambda
        if(alambda.gt.1000)alambda=1.
       end if
      else
       if(chisq.gt.ochisq) then 
        if(info.eq.-1) then 
         mfff=mf 
         do k=1,mf 
          kfff(k)=kf(k) 
          hhdp(k)=dp(k) 
         iff_opgtup(k)=if_opgtup(k) 
         end do 
        end if 
                                                                        
        mf=mff 
        do k=1,mf 
         kf(k)=kff(k) 
        end do 
        call trf_arr(mf,covar,uu) 
        alambda=10.0*alambda 
        if(alambda.gt.10)pathw=pathw/2.0 
!       chisq=ochisq                                                    
        do k=1,mf
         p(kf(k))=pold(kf(k)) 
         dp(k)=hdp(k) 
        i_opgtup(k)=if_opgtup(k) 
        end do 
        call calpl('free') 
        iter_count=-iter_count 
!       pathw=alambda                                                   
                                                                        
        if(info.eq.-1) then 
         mf=mfff 
         do k=1,mf 
          kf(k)=kfff(k) 
          hdp(k)=hhdp(k) 
          i_opgtup(k)=iff_opgtup(k) 
         end do 
         info=0 
        end if 
       else
        alambda=0.1*alambda        
       end if 
      end if                                                                     
      path1=pathw 
      path2=alambda 
      return 
      end if ! marquard 
                                                                        
                                                                        
!---------------------------------newton--------------------            
      if (cmch.eq.'newt') then
       omch='newt' 
!       write(6,'(a,8f10.3)')'fit newton p=',(p(kf(k)),k=1,mf)          
!      dp(k) for newton's method                                        
!      solve normal equations                                           
       alambda=0. 
       luu=1 
       mff=mf 
       do j=1,mf 
        kff(j)=kf(j) 
        hdp(j)=dp(j) 
        if_opgtup(j)=i_opgtup(j) 
       end do 
!       write(6,'(8g12.2)')(dp(k),k=1,mf)                               
       call trf_arr(mf,uu,covar) 
   10  call uinvdp(mf,covar,dp,fuu,alambda) 
!       write(6,'(8g12.2)')(dp(k),k=1,mf)                               
       if(i_confine.eq.1) then 
        h=0.0 
        do k=1,mf 
          fuu(k)=sqrt(abs(dp(k)/hdp(k))) 
          h=h+fuu(k) 
        end do 
!       write(6,'(i4,a,f10.3)')luu,'fit newton dp,pathwidth=',h,        
        if(h.gt.float(mf*luu)) then 
         luu=luu+1 
!         write(6,'(8g12.2)')(fuu(k),k=1,mf)                            
         fuu(0)=1.0 
         do k=1,mf 
          dp(k)=hdp(k) 
          if(fuu(k).lt.1.0) fuu(k)=1.0 
         end do 
         call trf_arr(mf,covar,uu) 
         goto 10 
        end if 
       end if 
                                                                        
       do k=1,mf 
        dp(k)=pathw*dp(k) 
       end do 
       if(boundary.gt.0.0) then 
        do k=1,mf 
         j=kf(k) 
         if(dp(k).gt.boundary*ddp(j))dp(k)=boundary*ddp(j) 
        end do 
       end if 
                                                                        
       do  k=1,mf 
        m=kf(k) 
        if(i_opgtup(k).eq.1) then 
         hop=p(m)+dp(k)-hopmp(k) 
         hup=p(m)+dp(k)-hupmp(k) 
         if(hop.gt.0.and.dp(k).gt.0.) then 
!          write(nwr,6800) np(kf(k)),p(m)+dp(k),hopmp(k),dp(k)          
          p(m)=p(m)+dp(k)*exp(-hop/dp(k))*tolimit 
          write(nwr,6800) np(kf(k)),p(m) 
         else if(hup.lt.0.and.dp(k).lt.0.) then 
!          write(nwr,6800) np(kf(k)),p(m)+dp(k),hupmp(k),dp(k)          
          p(m)=p(m)+dp(k)*exp(-hup/dp(k))*tolimit 
          write(nwr,6800) np(kf(k)),p(m) 
         else 
          p(m)=p(m)+dp(k) 
         end if 
        else 
         if(abs(dp(k)).gt.100.*abs(ddp(m)))then 
           z=sign(ddp(m),dp(k))/2.0 
           format='(a,i2,a2,g12.4,a,g12.4)' 
           if(k.gt.100)format='(a,i4,a2,g12.4,a,g12.4)' 
           write(nwr,format)                                            &
     &   ' -singular- dp(',k,')=',dp(k),' set to sign(ddp,dp)/2.0=',z   
           dp(k)=z 
         end if 
         p(m)=p(m)+dp(k) 
        end if 
       end do 
!       write(6,'(a)')'fit newton p='                                   
!       write(6,'(15f15.6)')(p(kf(k)),k=1,mf)                           
                                                                        
                                                                        
       call calpl('free') 
       call udp(mf,covar,chisq,pathw,chi_p,cmch,info) 
!      write(6,'(a,f15.5)')'fit chisq=',chisq                           
!      write(6,'(a,8f15.5)')'fit newton2 p=',(p(kf(k)),k=1,mf)          
       if(chisq.gt.ochisq.and.limit.eq.1) then 
        if(info.eq.-1) then 
         mfff=mf 
         do k=1,mf 
          kfff(k)=kf(k) 
          hhdp(k)=dp(k) 
          iff_opgtup(k)=i_opgtup(k) 
         end do 
        end if 
        mf=mff 
        do k=1,mf 
         kf(k)=kff(k) 
        end do 
        call trf_arr(mf,covar,uu) 
        pathw=pathw/2.0 
!        chisq=ochisq                                                   
        do k=1,mf 
         p(kf(k))=pold(kf(k)) 
         dp(k)=hdp(k) 
          i_opgtup(k)=if_opgtup(k) 
        end do 
        call calpl('free') 
        iter_count=-iter_count 
        if(info.eq.-1) then 
         mf=mfff 
         do k=1,mf 
          kf(k)=kfff(k) 
          hdp(k)=hhdp(k) 
          i_opgtup(k)=iff_opgtup(k) 
         end do 
         info=0 
        end if 
       end if 
                                                                        
       do k=1,mf 
        if(abs(dp(k)).gt.100.*abs(ddp(k)))then 
           format='(a,i2,a2,g15.4,a,g12.4)' 
           if(k.gt.100)format='(a,i4,a2,g15.4,a,g12.4)'
           z=sign(ddp(k),dp(k))/2.0
           write(nwr,format)                                            &
       ' -singular- dp(',k,')=',dp(k),' set to sign(ddp(k),dp(k))/2.0=',z
           dp(k)=z
        end if 
       end do 
       path1= pathw 
       return 
                 ! newton                                               
      end if 
                                                                        
!---------------------------------gradient--------------------          
      if(cmch.eq.'grad') then 
       omch='grad' 
!      gradient method                                                  
       mff=mf 
       odpudp=dpudp 
       do k=1,mf 
        kff(k)=kf(k) 
        hdp(k)=dp(k) 
        hukk(k)=ukk(k) 
        if_opgtup(k)=i_opgtup(k) 
       end do 
!       write(6,'(a,15f10.4)')'fit gradient dp=',(dp(k),k=1,mf)         
!       write(6,'(a,g10.4)')'dp,ukk,dpudp=',dpudp                       
!       write(6,'(8f10.4)')(ukk(k),k=1,mf)                              
       g1=0. 
       do k=1,mf 
        g1=g1+dp(k)*dp(k)*ukk(k) 
       end do 
       path1=g1/dpudp 
       g1=sqrt(g1) 
       path2=pathw/g1 
       if(path1.lt.path2) then 
        pathmin=path1 
        hpath=path1*g1 
       else 
        pathmin=path2 
        hpath=pathw 
       end if 
                                                                        
       do k=1,mf 
        dp(k)=pathmin*dp(k) 
       end do 
                                                                        
!       write(6,'(a,15f10.4)')'fit gradient dp=',(dp(k),k=1,mf)         
!       write(6,'(3(a,g15.3))') 'grad pathw=',pathw,                    
!     &         ' path1=',path1,' path2=',path2                         
!       write(6,'(a,f10.3)')'fit gradient dp,pathwidth=',pathw          
!       write(6,'(4(i3,2x,g15.4))')(kf(k),dp(k),k=1,mf)                 

       do  k=1,mf 
        m=kf(k) 
        if(i_opgtup(k).eq.1) then 
         hop=p(m)+dp(k)-hopmp(k) 
         hup=p(m)+dp(k)-hupmp(k) 
         if(hop.gt.0.and.dp(k).gt.0.) then 
!          write(nwr,6800) np(kf(k)),p(m)+dp(k),hopmp(k),dp(k)          
          p(m)=p(m)+dp(k)*exp(-hop/dp(k))*tolimit 
          write(nwr,6800) np(kf(k)),p(m) 
         else if(hup.lt.0.and.dp(k).lt.0.) then 
!          write(nwr,6800) np(kf(k)),p(m)+dp(k),hupmp(k),dp(k)          
          p(m)=p(m)+dp(k)*exp(-hup/dp(k))*tolimit 
          write(nwr,6800) np(kf(k)),p(m) 
         else 
          p(m)=p(m)+dp(k) 
         end if 
        else 
         if(abs(dp(k)).gt.100.*abs(ddp(m)))then 
           z=sign(ddp(m),dp(k))/2.0 
           format='(a,i2,a2,g15.4,a,g12.4)' 
           if(k.gt.100)format='(a,i4,a2,g15.4,a,g12.4)' 
           write(nwr,format)                                            &
        ' -singular- dp(',k,')=',dp(k),' set to sign(ddp,dp)/2.0=',z   
           dp(k)=z 
         end if 
         p(m)=p(m)+dp(k) 
        end if 
       end do 
!       write(6,'(3(a,f15.5))') 'grad before udp p(m)=',p(kf(1))        
                                                                        
       call calpl('free') 
       call udp(mf,covar,chisq,pathw,chi_p,cmch,info) 
                                                                        
       if(chisq.gt.ochisq.and.limit.eq.1) then 
!        write(6,'(3(a,f15.5))') 'grad ochisq=',ochisq,                 
!     &         ' chisq=',chisq,' chi_p=',chi_p                         
        if(info.eq.-1) then 
         mfff=mf 
         do k=1,mf 
          kfff(k)=kf(k) 
          hhdp(k)=dp(k) 
          hhukk(k)=ukk(k) 
          iff_opgtup(k)=i_opgtup(k) 
         end do 
        end if 
        mf=mff 
        pathw=hpath/2.0 
        dpudp=odpudp 
        do k=1,mf 
         kf(k)=kff(k) 
         p(kf(k))=pold(kf(k)) 
         dp(k)=hdp(k) 
         ukk(k)=hukk(k) 
         i_opgtup(k)=if_opgtup(k) 
        end do 
        call calpl('free') 
        iter_count=-iter_count 
        if(info.eq.-1) then 
         mf=mfff 
         do k=1,mf 
          kf(k)=kfff(k) 
          hdp(k)=hhdp(k) 
          ukk(k)=hhukk(k) 
          i_opgtup(k)=iff_opgtup(k) 
         end do 
         info=0 
        end if 
       end if 
       path1=pathw 
                  ! gradient                                            
      end if 
                                                                        
!--------------------------------Davidon-Fletcher-Powell-------------   
      if(cmch.eq.'powe') then 
       omch='powe'       !      Powell  method                                                   
                                                                        
       do i=1,mf 
        kpa=kf(i) 
        hp(i)=p(kpa) 
        hdp(i)=ddp(kpa) 
        namepp(i)=np(kpa) 
        hukk(i)=plast(kpa) 
       end do 
       i=nwr 
       call POWELL(hp,hdp,uu,mf,iter_count,                            &
                       ftol,iterbrake,iBR_DBR,ibx_calc,                &
                       df,PT,PTT,XIT,kff,                              &
                       kf,namepp,hukk,i,chisq)                         
                                                                        
       call DDFUNC(hp,hdp,uu,mf) 
       call trf_arr(mf,covar,uu) 
                                                                        
       do i=1,mf 
        p(kf(i))=hp(i) 
       end do 
                                                                        
      end if 
                                                                        
                                                                        
!--------------------------Broyden-Fletcher-Goldfarb-Shanno---------    
      if(cmch.eq.'dfpm') then 
       omch='dfpm' 
!      Davidon-Fletcher-Powell  method                                  
!      iter_count = max iterations > 1                                  
                                                                        
       do i=1,mf 
        kpa=kf(i) 
        hp(i)=p(kpa) 
        hdp(i)=pathw*ddp(kpa) 
        namepp(i)=np(kpa) 
        hukk(i)=plast(kpa) 
       end do 
                                                                        
       i=nwr 
       call  DFPMIN(hp,hdp,uu,mf,iter_count,                            &
     &                  ftol,iterbrake,iBR_DBR,ibx_calc,                &
     &                  df,PT,PTT,XIT,kff,                              &
     &                  kf,namepp,hukk,i,chisq)                         
                                                                        
                                                                        
                                                                        
                                                                        
       call ausg(hp,hdp,uu,mf,df) 
                                                                        
       do i=1,mf 
        kpa=kf(i) 
!       if(i_opgtup(i).eq.1) then                                       
!        if(hdp(i).gt.op(kpa))then                                      
!         hdp(i)=op(kpa)                                                
!        else if(hdp(i).lt.up(kpa))then                                 
!         hdp(i)=up(kpa)                                                
!        end if                                                         
!       end if                                                          
        p(kpa)=hp(i) 
       end do 
                                                                        
      end if 
                                                                        
      return 
                                                                        
!     ******************************************************************
 6800 format(' ****warning****  parameter ',a24,                        &
             ' limit exceeded',4g15.6)                                         
      END                                           
                                                                        
                                                                        
       subroutine  ausg(hp,hdp,ddf,mf,df) 
       implicit none
       integer   mf,i
       real,dimension(mf,mf)::ddf    
       real,dimension(mf):: df,hp,hdp
       real f0
                                                                        
       call DDFUNC(hp,hdp,ddf,mf) 
       CALL DFUNC(hp,hdp,f0,df,mf) 
       i=0 
       call lineq(i,mf,ddf,df) 
       return 
      END                                           
                                                                        
      subroutine uubes(uii,mf,uu) 
      implicit none
      integer mf,i,k 
       real,dimension(mf,mf):: uu
       real,dimension(mf)   :: uii
       do i=1,mf 
        do k=1,mf 
         uu(i,k)=0. 
        end do 
       end do 
       do i=1,mf 
        uu(i,i)=uii(i) 
       end do 
      return 
      END                                           
